package com.winhc.data.push.common;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.Column;
import com.winhc.data.push.bean.TaskRunParam;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;


/**
 * @author π
 * @since 2021-11-2 15:50
 */
@Data
@NoArgsConstructor
public class TaskRunMap {


    private TaskRunParam taskRunParam;

    public static final Map<String, TaskRunMap> TASK_ARGS = createArgs();


    public TaskRunMap(TaskRunParam taskRunParam) {
        this.taskRunParam = taskRunParam;
    }


    private static Map<String, TaskRunMap> createArgs() {
        HashMap<String, TaskRunMap> a = new HashMap<>();
        a.put("gw", new TaskRunMap(
                TaskRunParam
                        .builder()
                        .customer_name("gw")
                        .source_table("bds_change_out_sql_gw")
                        .syn_upload_tasks("syn_gw_upload_tasks")
                        .datasource("oss_data_gw")
                        .bucket_name("data-exchange-out-gw")
                        .oss_pre("data/gw")
                        .detail_suffix(".sql")
                        .tns_sql_pre("SHOW PARTITIONS bds_change_out_sql_gw PARTITION (ds = '@ds') ;")
                        .tns_out(Constant.gw_company_tns)
                        .flow_name("base_opds_push_data_oss_v2")
                        .flow_task_name("winhc_ng:base_opds_push_data_oss_v2:base_opds_push_data_oss_v2")
                        .build()
        ));
        return a;
    }
}
