package com.winhc.data.push.task;


import com.aliyun.openservices.shade.org.apache.commons.lang3.StringUtils;
import com.winhc.data.push.bean.TaskRunParam;
import com.winhc.data.push.common.Constant;
import com.winhc.data.push.common.TaskEnum;
import com.winhc.data.push.service.SynDataService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.bson.Document;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;

import static com.winhc.data.push.common.Constant.GW_DATASOURCE;
import static com.winhc.data.push.common.TaskRunMap.TASK_ARGS;
import static com.winhc.data.push.constant.BaseParam.SYN_GW_UPLOAD_TASKS;
import static com.winhc.data.push.constant.BaseParam.SYN_TC_UPLOAD_TASKS;

/**
 * @author π
 * @Description:国网数据触发任务
 * @date 2021/6/22 17:07
 */

@Component
@Slf4j
@EnableScheduling
@AllArgsConstructor
public class GwPushDataTask {

    private final SynDataService synDataService;

    @Scheduled(cron = "*/10 * * * * ?")
    //@Scheduled(cron = "0 /2 * * * ? ")
    public synchronized void start() {
        log.info("start " + this.getClass() + " !!! ");
        //任务配置参数
        TaskRunParam runParam = TASK_ARGS.get("gw").getTaskRunParam();
        //获取运行任务
        List<Document> allTask = synDataService.findAllTask(runParam.getSyn_upload_tasks(), new Document("status", TaskEnum.STATUS.CREATE.code));
        allTask.forEach(task -> {
            String ds = task.getString("ds");
            List<String> tns = task.getList("tns", String.class);
            if (StringUtils.isNotBlank(ds)) {
                synDataService.pushGw(tns, ds, runParam);
            }
        });
        log.info("stop " + this.getClass() + " !!! ");

    }


}
